<?php
namespace PME\Controllers\Requisicao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class HistoricoRequisicaoAnalController extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $birtStrategy, $environment) {
      $this->birtStrategy  = $birtStrategy;
      $this->environment   = $environment;

      parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME03800' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "DTDE"         => "P_DTINICIAL",
              "DTATE"        => "P_DTFINAL",
              "OPERADOR"     => "P_CDOPERADOR",
              "TIPOCARD"     => "P_CDTIPOCARD",
              "SERVICO"      => "P_CDSERVFILI",
              "UNIDADE"      => "P_CDFILIAL",
              "NRORG"        => "P_NRORG",
            )
        ),
      'PME03801' => 
        array (
          'strategy' => 'BIRT',
          'parameterMapping' => 
          array (
            "DTDE"         => "P_DTINICIAL",
            "DTATE"        => "P_DTFINAL",
            "OPERADOR"     => "P_CDOPERADOR",
            "TIPOCARD"     => "P_CDTIPOCARD",
            "SERVICO"      => "P_CDSERVFILI",
            "UNIDADE"      => "P_CDFILIAL",
            "NRORG"        => "P_NRORG",
          )
      )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->environment->getNrOrg();
      
      if(empty($row['OPERADOR'])){
        $row['OPERADOR'] = 'T';
      } else if(is_array($row['OPERADOR'])){
        $row['OPERADOR'] = join("_", $row['OPERADOR']);
      }
      
      if(empty($row['tipoCardHistorico'])){
        $row['TIPOCARD'] = 'T';
      } else if(is_array($row['tipoCardHistorico'])){
        $row['TIPOCARD'] = join("_", $row['tipoCardHistorico']);
      }
      
      if(empty($row['servicoHistorico'])){
        $row['SERVICO'] = 'T';
      } else if(is_array($row['servicoHistorico'])){
        $row['SERVICO'] = join("_", $row['servicoHistorico']);
      }
      
      if(empty($row['unidadeHistorico'])){
        $row['UNIDADE'] = 'T';
      } else if(is_array($row['unidadeHistorico'])){
        $row['UNIDADE'] = join("_", $row['unidadeHistorico']);
      }
      
      $row['NRORG'] = $nrorg;
      
      $this->birtStrategy->setReportLocale($this->environment->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}