<?php
namespace Avaliacao\Entities;

use Geral\Util\NovoCodigo;

class AvlFontedados extends Base\AvlFontedados
{
    public function retornaFonteDados($nrorg, $cdintegracao){
        $obj = self::getObjectByWhere(
            'NRORG = ? AND CDINTEGRACAO = ?',
            array(
                $nrorg,
                $cdintegracao,
            )
        );
        return $obj;
    }

    public function atualizaUltFilialLocalPainel
    (
        $nrorg,
        $cdintegracao,
        $ult_filial,
        $ult_local_avalicao
    ){
        $obj = AvlFontedados::getObjectsByWhere(
            'NRORG = ? AND CDINTEGRACAO = ?',
            array(
                $nrorg,
                $cdintegracao,
            )
        );

        /** @var $painel AvlFontedados */
        foreach ($obj as $painel) {
            $painel->setCdfilial($ult_filial);
            $painel->setNrlocalavaliacao($ult_local_avalicao);

            $painel->persist();
        }

        return true;


    }

    public function insereFonteDados(
        $cdintegracao,
        $nrorg
    ){
        try {
            $obj = new self();
            $obj->setNrfontedados(NovoCodigo::geraCodigo($nrorg, 'AVLFONTEDADOS',1,10,true));
            $obj->setNmfontedados($cdintegracao);
            $obj->setCdintegracao($cdintegracao);
            $obj->setIdativo('S');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);

            $obj->persist();
            return true;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }

    }
}